import { querystring } from './util'

function minutes (t) {
  return t * 1000 * 60
}

function safeParse (str) {
  try { return JSON.parse(str) } catch (err) {}
}

export function session () {
  const qs = querystring()
  let s = get()

  if (qs.utm_campaign && !s.name) {
    s.name = qs.utm_campaign
  }
  if (qs.utm_source && !s.source) {
    s.source = qs.utm_source
  }
  if (qs.utm_medium && !s.medium) {
    s.medium = qs.utm_medium
  }
  if (qs.utm_term && !s.term) {
    s.term = qs.utm_term
  }
  if (qs.utm_content && !s.content) {
    s.content = qs.utm_content
  }
  if (qs.utm_keyword && !s.keyword) {
    s.keyword = qs.utm_keyword
  }
  if (qs.utm_network && !s.network) {
    s.network = qs.utm_network
  }
  if (qs.utm_creative && !s.creative) {
    s.creative = qs.utm_creative
  }
  if (qs.utm_matchtype && !s.matchtype) {
    s.matchtype = qs.utm_matchtype
  }
  if (qs.gclid && !s.gclid) {
    s.gclid = qs.gclid
  }
  if (qs.jmp && !s.jmp) {
    s.jmp = qs.jmp
  }

  window.localStorage.setItem('__session', JSON.stringify(s))
}

function get () {
  const s = safeParse(window.localStorage.getItem('__session')) || { timestamp: 0 }

  if ((s.timestamp || 0) < (Date.now() - minutes(30))) {
    return { timestamp: Date.now() }
  } else {
    return s
  }
}

session.get = get
